import { extend, mergeData } from '../../vue';
import { NAME_CARD_FOOTER } from '../../constants/components';
import { PROP_TYPE_STRING, PROP_TYPE_ARRAY_OBJECT_STRING } from '../../constants/props';
import { htmlOrText } from '../../utils/html';
import { sortKeys } from '../../utils/object';
import { makePropsConfigurable, copyProps, prefixPropName, makeProp } from '../../utils/props';
import { props as props$1 } from '../../mixins/card';

// --- Props ---

const props = makePropsConfigurable(sortKeys({
  ...copyProps(props$1, prefixPropName.bind(null, 'footer')),
  footer: makeProp(PROP_TYPE_STRING),
  footerClass: makeProp(PROP_TYPE_ARRAY_OBJECT_STRING),
  footerHtml: makeProp(PROP_TYPE_STRING)
}), NAME_CARD_FOOTER);

// --- Main component ---

// @vue/component
const BCardFooter = /*#__PURE__*/extend({
  name: NAME_CARD_FOOTER,
  functional: true,
  props,
  render(h, _ref) {
    let {
      props,
      data,
      children
    } = _ref;
    const {
      footerBgVariant,
      footerBorderVariant,
      footerTextVariant
    } = props;
    return h(props.footerTag, mergeData(data, {
      staticClass: 'card-footer',
      class: [props.footerClass, {
        [`bg-${footerBgVariant}`]: footerBgVariant,
        [`border-${footerBorderVariant}`]: footerBorderVariant,
        [`text-${footerTextVariant}`]: footerTextVariant
      }],
      domProps: children ? {} : htmlOrText(props.footerHtml, props.footer)
    }), children);
  }
});

export { BCardFooter, props };
